"""The product type for IP trunks, does not contain any special variables apart from the corresponding product block."""

from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.iptrunk import (
    IptrunkBlock,
    IptrunkBlockInactive,
    IptrunkBlockProvisioning,
)


class IptrunkInactive(SubscriptionModel, is_base=True):
    """An IP trunk that is inactive."""

    iptrunk: IptrunkBlockInactive


class IptrunkProvisioning(IptrunkInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    """An IP trunk that is being provisioned."""

    iptrunk: IptrunkBlockProvisioning


class Iptrunk(IptrunkProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """An IP trunk that is active."""

    iptrunk: IptrunkBlock
